/* utmp_lib.h
 * (c)17.10.1998 by Marek Zelem
 */

#include "sysdep.h"

#ifndef	GOOD_UTMP

#ifndef	BAD_UTMP
#error "Your system has unknown format of utmp!"
#else  BAD_UTMP
#ifndef TEST
#warning "struct utmp defined in your standard header is wrong, but tell support your real format of utmp."
#endif  TEST
#endif  BAD_UTMP

#include <paths.h>

#define UTMP_FILE       _PATH_UTMP
#define WTMP_FILE       _PATH_WTMP

#define UTMP_FILENAME   UTMP_FILE
#define WTMP_FILENAME   WTMP_FILE

/* defines for the ut_type field */
#define UT_UNKNOWN      0

#define RUN_LVL         1
#define BOOT_TIME       2
#define NEW_TIME        3
#define OLD_TIME        4

#define INIT_PROCESS    5
#define LOGIN_PROCESS   6
#define USER_PROCESS    7
#define DEAD_PROCESS    8
 

#define	mUT_LINESIZE	32
#define	mUT_NAMESIZE	32
#define	mUT_HOSTSIZE	256

struct m_utmp
{
	short   ut_type;        /* type of login */
	pid_t   ut_pid;         /* pid of login-process */
	char    ut_line[mUT_LINESIZE];   /* devicename of tty -"/dev/", null-term */
	char    ut_id[4];       /* inittab id */
	time_t  ut_time;        /* login time */
	char    ut_user[mUT_NAMESIZE];   /* username, not null-term */
	char    ut_host[mUT_HOSTSIZE];   /* hostname for remote login... */
	long    ut_addr;        /* IP addr of remote host */
};


void m_utmpname(const char *file);

void m_setutent(void);
void m_endutent(void);
struct m_utmp *m_getutent(void);

#else	GOOD_UTMP

#include <utmp.h>
#define	m_utmp	utmp
#define	m_utmpname	utmpname
#define	m_setutent	setutent
#define	m_endutent	endutent
#define m_getutent	getutent

#define	mUT_LINESIZE	UT_LINESIZE
#define	mUT_NAMESIZE	UT_NAMESIZE
#define	mUT_HOSTSIZE	UT_HOSTSIZE

#endif	BAD_UTMP

